routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

Route::resource('alumno', AlumnoController::class);
Route::resource('curso', CursoController::class);
Route::resource('practica', PracticaController::class);
Route::resource('pertenece', PerteneceController::class);
Route::resource('presenta', PresentaController::class);


// Enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('/practica/confirmar/{practica}', 'confirmar')->name('practica.confirmar');
});

// Enrutamiento adicional para Pertenece
Route::controller(PerteneceController::class)->group(function () {
    Route::get('/pertenece/confirmar/{pertenece}', 'confirmar')->name('pertenece.confirmar');
});

// Enrutamiento adicional para Presenta
Route::controller(PresentaController::class)->group(function () {
    Route::get('/presenta/confirmar/{presenta}', 'confirmar')->name('presenta.confirmar');
});

app/Models/Presenta.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Presenta extends Model {
    use HasFactory;

    protected $table = 'presentas';

    // Campos de asignación masiva
    protected $fillable = [
        'alumno_id',
        'practica_id',
        'nota',
    ];

    // Nombre de los campos  de las tablas
    public static $labels = [
        'id' => 'ID Presenta',
        'alumno_id' => 'ID Alumno',
        'practica_id' => 'ID Practica',
        'nota' => 'Nota Alumno',
        'titulocurso' => 'Título de la Práctica',
        'nombrecurso' => 'Nombre Curso',
    ];

    /**
     ** Recupera la lista de campos de la tabla asociada al modelo.
     *
     * @return array La lista de nombres de campos.
    */
    public function getFields(): array {
        return Schema::getColumnListing($this->table);
    }

    /**
     ** Recupera la etiqueta de un atributo dado.
     *
     * @param string $attribute El nombre del atributo.
     * @return string La etiqueta del atributo, o el nombre del atributo si no se encuentra una etiqueta.
    */
    public function getAttributeLabel($attribute): string {
        return self::$labels[$attribute] ?? $attribute;
    }

    /**
     ** Obtiene la lista de campos de la modelo de tabla asociada.
     *
     * @return array|BelongsTo La lista de nombres de campos asociados a Alumno.
    */
    public function alumno() : BelongsTo {
        return $this->belongsTo(Alumno::class, 'alumno_id');
    }

    /**
     ** Obtiene la lista de campos de la modelo de tabla asociada.
     *
     * @return array|BelongsTo La lista de nombres de campos asociados a Practica.
    */
    public function practica() : BelongsTo {
        return $this->belongsTo(Practica::class, 'practica_id');
    }

    public function getTitulocursoAttribute(): string {
        return $this->practica->titulo;
    }

    public function getNombreCursoAttribute(): string {
        return $this->curso->nombre;
    }
}

app/Http/Controllers/PresentaController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PresentaStoreRequest;
use App\Http\Requests\PresentaUpdateRequest;
use App\Models\Alumno;
use App\Models\Practica;
use App\Models\Presenta;
use Illuminate\Http\Request;

class PresentaController extends Controller {
    /**
     * Display a listing of the resource.
     */
    public function index() {
        $presentas = Presenta::all();

        return view('presenta.index', compact('presentas'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create() {
        $practicas = Practica::all();
        $alumnos = Alumno::all();

        return view('presenta.create', compact('practicas', 'alumnos'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(PresentaStoreRequest $request) {
        $presenta = Presenta::create($request->all());

        return redirect()
            ->route('presenta.show', $presenta)
            ->with('mensaje', 'Presenta se ha creado con éxito')
        ;
    }

    /**
     * Display the specified resource.
     */
    public function show(Presenta $presentum) {;
        return view('presenta.show', compact('presentum'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Presenta $presentum) {
        $practicas = Practica::all();
        $alumnos = Alumno::all();

        return view('presenta.edit', compact('presentum', 'practicas', 'alumnos'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(PresentaUpdateRequest $request, Presenta $presentum) {
        $presentum->update($request->all());

        return redirect()
            ->route('presenta.show', $presentum)
            ->with('mensaje', 'Presenta actualizado con éxito')
        ;
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Presenta $presentum) {
        $presentum->delete();

        return redirect()
            ->route('presenta.index')
            ->with('mensaje', 'Presenta borrado con éxito')
        ;
    }

    public function confirmar(Presenta $presenta) {
        return view('presenta.confirmar', compact('presenta'));
    }
}

resources/views/presenta/confirmar.blade.php
@extends('layouts.main')

@section('content')
    <h1>Eliminar Presenta</h1>

    <div>
        <a href="{{ route('presenta.index') }}" class="boton">Volver</a><br><br>
    </div>

    <div class="tarjeta">
        <ul>
            <li>ID: {{ $presenta->id }}</li>
            <li>Nota: {{ $presenta->nota }}</li>
            <li>Practica ID: {{ $presenta->practica_id }} - {{ $presenta->practica->titulo }}</li>
            <li>Alumno ID: {{ $presenta->alumno_id }} - {{ $presenta->alumno->nombre }}</li>
        </ul>

        <div class="botones">
            <form action="{{ route('presenta.destroy', $presenta)}}" method="POST" >
                @csrf @method('DELETE')
                <button class="boton" type="submit">Borrar</button>
            </form>
        </div>
    </div>

@endsection

resources/views/presenta/create.blade.php
@extends('layouts.main')

@section('content')
    <h1>Crear Presenta</h1>

    @if ($errors->any())
        <div class="">
            <div class="" style="">
                <h2 class="">Error</h2>

                @foreach ($errors->all() as $error)
                    <p class=""> {{ $error }} </p>
                @endforeach
            </div>
        </div>
    @endif

    <a href="{{ route('presenta.index') }}" class="boton">Volver</a>

    <form action="{{ route('presenta.store') }}" method="POST" enctype="multipart/form-data">
        @csrf

        <div>
            <label for="nota">Nota</label>
            <input type="number" name="nota" id="nota">
        </div>

        <div>
            <label for="practica_id">Practica ID</label>

            <select name="practica_id" id="practica_id">
                <option value="">-- Seleccione --</option>

                @foreach ($practicas as $practica)
                    <option value="{{ $practica->id }}">{{ $practica->titulo }}</option>
                @endforeach
            </select>
        </div>

        <div>
            <label for="alumno_id">Alumno ID</label>

            <select name="alumno_id" id="alumno_id">
                <option value="">-- Seleccione --</option>

                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}">{{ $alumno->nombrecompleto }}</option>
                @endforeach
            </select>
        </div>

        <div>
            <button class="boton" type="submit">Crear</button>
        </div>
    </form>
@endsection

resources/views/presenta/edit.blade.php
@extends('layouts.main')

@section('content')
    <h1>Editar Presenta</h1>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p class="">{{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    @if ($errors->any())
        <div class="">
            <div class="" style="background-color: gray">
                <h2 class="">Error</h2>
                @foreach ($errors->all() as $error)
                    <p class=""> {{ $error }} </p>
                @endforeach
            </div>
        </div>
    @endif

    <br><a href="{{ route('presenta.index') }}" class="boton">Volver</a><br>


    <form action="{{ route('presenta.update', $presentum) }}" method="POST"  enctype="multipart/form-data">
        @csrf
        @method('PUT')

        <div>
            <label for="nota">Nota</label>
            <input type="number" name="nota" id="nota" value="{{ old('nota', $presentum->nota) }}">
        </div>

        <div>
            <label for="practica_id">Practica ID</label>

            <select name="practica_id" id="practica_id">
                <option value="">-- Seleccione --</option>

                @foreach ($practicas as $practica)
                    <option value="{{ $practica->id }}" {{ $presentum->practica_id == $practica->id ? 'selected' : '' }}>{{ $practica->titulo }}</option>
                @endforeach
            </select>
        </div>

        <div>
            <label for="alumno_id">Alumno ID</label>

            <select name="alumno_id" id="alumno_id">
                <option value="">-- Seleccione --</option>

                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}" {{ $presentum->alumno_id == $alumno->id ? 'selected' : '' }}>{{ $alumno->nombrecompleto }}</option>
                @endforeach
            </select>
        </div>

        <div>
            <button class="boton" type="submit">Actualizar</button>
        </div>
    </form>
@endsection

resources/views/presenta/index.blade.php
@extends('layouts.main')

@section('content')
    <h1>Listado Presenta</h1>

    <div>
        <a href="{{ route('presenta.create') }}" class="boton">Crear presenta</a><br><br>
    </div>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    <div class="listado">
        @foreach ($presentas as $presenta)
            <div class="tarjeta">
                <ul>
                    <li><a href="{{ route('presenta.show', $presenta) }}" >ID:</a> {{ $presenta->id }}</li>
                    <li>Nota: {{ $presenta->nota }}</li>
                    <li>Practica ID: {{ $presenta->practica_id }} - {{ $presenta->practica->titulo }}</li>
                    <li>Alumno ID: {{ $presenta->alumno_id }} - {{ $presenta->alumno->nombre }}</li>
                </ul>

                <div class="botones">
                    @php
                        $id=$presenta;
                    @endphp
                    <a href="{{ route('presenta.show', $presenta) }}" class="boton">Ver</a>
                    <a href="{{ route('presenta.edit', $presenta) }}" class="boton">Editar</a>

                    <form action="{{ route('presenta.destroy', $presenta)}}" method="POST" id="eliminar">
                        @csrf @method('DELETE')
                        <button class="boton" type="submit">Borrar</button>
                    </form>

                    <a href="{{ route('presenta.confirmar', $presenta) }}" class="boton"> Eliminar 2 </a>
                </div>
            </div>
        @endforeach
    </div>
@endsection

resources/views/presenta/show.blade.php
@extends('layouts.main')

@section('content')
    <h1>Listado Presenta</h1>

    <div>
        <a href="{{ route('presenta.index') }}" class="boton">Volver</a><br><br>
    </div>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    <div class="tarjeta">
        <ul>
            <li>ID: {{ $presentum->id }}</li>
            <li>Nota: {{ $presentum->nota }}</li>
            <li>Practica ID: {{ $presentum->practica_id }} - {{ $presentum->practica->titulo }}</li>
            <li>Alumno ID: {{ $presentum->alumno_id }} - {{ $presentum->alumno->nombre }}</li>
        </ul>

        <div class="botones">
            <a class="boton" href="{{ route('presenta.edit', $presentum) }}">Editar</a>

            <form action="{{ route('presenta.destroy', $presentum)}}" method="POST" id="eliminar">
                @csrf @method('DELETE')
                <button class="boton" type="submit">Borrar</button>
            </form>

            {{-- <a href="{{ route('presenta.confirmar', $presenta) }}" class="boton"> Eliminar 2 </a> --}}
        </div>
    </div>
@endsection